﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using Wisej.Web;

namespace Wisej.DGVVirtualMode
{
	public partial class Page1 : Page
	{
		public Page1()
		{
			InitializeComponent();
		}

		// simulate the data source.
		List<Record> data = new List<Record>();

		private void Page1_Load(object sender, EventArgs e)
		{
		}

		private void button1_Click(object sender, EventArgs e)
		{
			BuildData();
			var rowCount = this.data.Count;

			// set total number of rows first.
			// it will start firing CellValueNeeded to retrieve the
			// cell values when in VirtualMode.

			this.dataGridView1.Rows.Clear();
			this.dataGridView1.RowCount = rowCount;
		}

		private void BuildData()
		{
			var rowCount = (int)this.numericUpDown1.Value;
			this.data = new List<Record>(rowCount);
			for (int i = 0; i < rowCount; i++)
			{
				data.Add(new Record()
				{
					Column0 = $"Column0; Row: {i}",
					Column1 = $"Column1; Row: {i}",
					Column2 = $"Column2; Row: {i}",
					Column3 = $"Column3; Row: {i}",
					Column4 = $"Column4; Row: {i}",
				});
			}
		}

		private void dataGridView1_CellValueNeeded(object sender, DataGridViewCellValueEventArgs e)
		{
			if (this.data.Count > e.RowIndex)
			{
				var name = this.dataGridView1.Columns[e.ColumnIndex].Name;
				var dataRow = this.data[e.RowIndex];
				e.Value = TypeDescriptor.GetProperties(dataRow)[name].GetValue(dataRow);
			}
		}
	}
}
